__author__  = 'Tom-Wilkin Martinussen <tom@oberon.no>'

from AccessControl import ClassSecurityInfo, AuthEncoding

from zope.interface import implements

from Products.CMFCore import permissions
from AccessControl import getSecurityManager, ClassSecurityInfo
from Products.Archetypes.interfaces.orderedfolder import IOrderedFolder
from Products.ATContentTypes.atct import ATFolder, ATFolderSchema
from Products.ATContentTypes.atct import ATCTContent, ATContentTypeSchema
from config import *
from Products.ATContentTypes.configuration import zconf
from Products.Archetypes.public import registerType
from Products.Archetypes.public import DisplayList
from Products.CMFCore.utils import getToolByName
from Products.Archetypes.public import ImageField
from Products.ATContentTypes.content.document import ATDocument

from Products.validation.config import validation
from Products.validation import V_REQUIRED
from Products.validation.validators.SupplValidators import MaxSizeValidator
from Products.CMFCore.permissions import View

validation.register(MaxSizeValidator('checkNewsImageMaxSize',
                                     maxsize=zconf.ATNewsItem.max_file_size))

from Products.validation.validators.SupplValidators import MaxSizeValidator


try:
	from Products.LinguaPlone.public import *
except ImportError:
	# No multilingual support
	from Products.Archetypes.public import *

schema  = ATFolderSchema.copy() + Schema((

			StringField('version_type', 
					searchable=0, 
				    required=True,
		            vocabulary=DisplayList((('Final', u'Final'),
		                                    ('Beta', u'Beta'),
		                                    ('Alpha', u'Alpha'),)),
				    widget=SelectionWidget(label='Version type',
										   format='select',
										   description='Select what kind of release it is'),
				  ),
				  
			TextField('changelog',
		            searchable = 1,
		            required = False,
		            allowable_content_types = ('text/plain',
		                                       'text/structured',
		                                       'text/html',),
		            default_output_type = 'text/x-html-safe',
		            widget = RichWidget(label = 'Changelog',
		            					description='Complete changelog. Whats new since last time.'),
		   ),
			StringField('Licence',
					searchable=0,
					required=True,
					default='plone',
					vocabulary=DisplayList((('GPL - Gnu General Public Licence', u'GPL - Gnu General Public Licence'),)),
					widget=SelectionWidget(label=u'Licence',
					                       description="Choose a license for the release",
					    				   format='select'
					    				   ),
			),
			
			StringField('compatibility', 
		                    index='FieldIndex:schema',
					searchable=0, 
				    required=True,
		            vocabulary=DisplayList((('Plone 3.0', u'Plone 3.0'),
		                                    ('Plone 2.5', u'Plone 2.5'),
		                                    ('Zope 2.10.4', u'Zope 2.10.4'),
		                                    ('Zope 2.9.4', u'Zope 2.9.4'),)),
				    widget=MultiSelectionWidget(label='Compatibility',
				    format='select',
					description='select the softwares compatibility. Hold ctrl to multi-select'),
				  ),

 )
)

schema['relatedItems'].widget.visible = False
schema['title'].widget.label = 'Version'
#schema.moveField('relatedItems', pos='bottom')

class Release(ATFolder, ATDocument):
    """ A new release """
    
    schema = schema
    
    meta_type = archetype_name = portal_type = 'Release'
    content_icon = 'download_icon.gif'
    _at_rename_after_creation = True
    global_allow = 0
    immediate_view = 'release_view'
    default_view = 'release_view'
    
    filter_content_types = 1
    allowed_content_types = ('File')

    
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/release_view',
        'permissions': (permissions.View,)
        },{
        'id': 'edit',
        'name': 'Edit',
        'action': 'string:${object_url}/base_edit',
        'permissions': (permissions.ViewManagementScreens,)
        },{
        'id': 'metadata',
        'name': 'Properties',
        'action': 'string:${object_url}/base_metadata',
        'permissions': (permissions.ViewManagementScreens,)
        },)
        
    security = ClassSecurityInfo()
        
    security.declareProtected(View, 'tag')
    def tag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        if 'title' not in kwargs:
            kwargs['title'] = self.getImageCaption()
        return self.getField('image').tag(self, **kwargs)
        

registerType(Release, PROJECTNAME)
